/*Written by Andrew Ortner
4 bit Modus
if LCD Ports and Pins should be changed, then lcd_data and lcd_command should be also adapted in this code
currently is PORTA as LCDPORT and this are the upper bits
The other Pins prom the LCD PORT can be free used*/
#define LCD_PORT PORTB
#define LCD_DDR DDRB
#define LCD_RS 2
#define LCD_E 3
#define LCD_DB4 4
#define LCD_DB5 5
#define LCD_DB6 6
#define LCD_DB7 7
#define LCD_Line_1 0x00
#define LCD_Line_2 0x40
#define LCD_Line_3 0x10
#define LCD_Line_4 0x50
#define LCD_clear_display 1
#define LCD_cursor_at_home 2
//#define LCD_print(str)	lcd_write_string(LCD_Line_1,str)
void lcd_init(void);void delms(int);void delus(int);void enable (void);void lcd_data (u08);
void lcd_command (u08);void lcd_write_string(u08, char *what);void lcd_print_time(void);
void lcd_write_char(u08 where, char what);
void lcd_init(void)
{
	LCD_DDR=0xFF;            // use all pins on PortB for output 
	delms(30);
	LCD_PORT=(1<<LCD_DB5);enable();	 //
	LCD_PORT=(1<<LCD_DB5);enable();  //
	LCD_PORT=(1<<LCD_DB7);enable();  //
	delus(50);
	LCD_PORT=0x00;enable(); 		 //Display ON/Off
	LCD_PORT=0xF0;enable();		     //
	delus(50);
	LCD_PORT=0x00;enable(); 		 //Cler Display 
	LCD_PORT=0x60;enable();		     //
	delms(2);			
}
void enable (void)
{
	SETBIT(LCD_PORT,LCD_E); delus(900); CLEARBIT(LCD_PORT,LCD_E);		//900
}
void lcd_data (u08 sw)
{	
	u08 sw_backup = sw;
	sw &=0xF0;	 //delete lower nibble
	SETBIT(sw,LCD_RS);
	LCD_PORT=sw;enable();  	  //
	sw_backup <<= 4;
	sw_backup &=0xF0;SETBIT(sw_backup,LCD_RS);	
	LCD_PORT=sw_backup;enable();	  

	
	/*u08 sw_backup = sw;
	sw |=0x0F;	 //set lower nibble
	LCD_PORT &=0x0F; //delete lower higher nibble
	LCD_PORT|=sw;SETBIT(LCD_PORT,LCD_RS);enable();  	  //
	sw_backup <<= 4;
	sw_backup |=0x0F; LCD_PORT &=0x0F; LCD_PORT=sw_backup;
	SETBIT(LCD_PORT,LCD_RS);enable();	  //
	CLEARBIT(LCD_PORT,LCD_RS); */
}
void lcd_command (u08 sw)
{	
    u08 sw_backup = sw;	sw &=0xF0; //delete lower nibble
	LCD_PORT=sw;	enable();	  //
	sw_backup <<= 4;
	LCD_PORT=sw_backup;	enable();//
	
	
	/*u08 sw_backup = sw;
	sw |=0x0F;	 //set lower nibble
	LCD_PORT &=0x0F; //delete lower higher nibble
	LCD_PORT|=sw;CLEARBIT(LCD_PORT,LCD_RS);enable();	  
	sw_backup <<= 4;
	sw_backup |=0x0F; LCD_PORT &=0x0F; LCD_PORT=sw_backup;CLEARBIT(LCD_PORT,LCD_RS);enable();*/
}
void lcd_write_string(u08 where, char *what)
{
	int j;char ch;
	lcd_command(128 + where);	
	for(j=0;j<50;j++) {ch=*(what++);if(ch=='\0')break;lcd_data(ch);}
}
void lcd_write_char(u08 where, char what)
{
	lcd_command(128 + where);lcd_data(what);
}
void lcd_print_time(void)
{
	sprintf(s, "%d", time.hour);sprintf(s2, ":%d", time.minute);
	strcat(s,s2);sprintf(s2, ":%d", time.second);strcat(s,s2);
	lcd_write_string(LCD_Line_1+8,&s[0]);
}


