

//#include <io.h>
//#include <ina90.h>      // 20010728, wg. _NOP()
//#include "globals.h"    // Globale Variablendefinitionen
//#include "DefProjekt.h"	// fr Projektspezifische Definitionen/ Konstanten/ Variablen
//#include "timer.h"	// wg. Wait_us()
//#include "i2c.h"
#include "PCF8591.h"

/******************************************************************************
Funktion: 	Beschreibt PCF8591 der SlaveNr (0..7) mit		      *
ControlByte - bei gesetztem AOEF (AnalogOutputEnableFlag)     *
wird der zuvor bermittelte Analogwert ausgegeben!	      *
Achtung, bergebener Analogwert wird erst beim _nchsten_ Schreiben 	      *
ausgegeben!								      *
******************************************************************************/
void I2C_PCF8591Write (u08 SlaveNr, u08 ControlByte, u08 AnalogWert)
{
  //Fehlernr = 0;
  
  // Startcondition
  //I2C_START;
  i2c_start();
  i2c_WR(i2cAnaPortA,0x55);

  // SlaveNr ausgeben
  //SlaveAdresse = ((PCF8591<<1) | (SlaveNr<<1));		// Write (Readbit nicht gesetzt)
  //I2CWriteByte(SlaveNr);	
  //I2CReadAck();

  // ControlByte ausgeben
  //I2CWriteByte(ControlByte);
  //I2CReadAck();

  // Analogwert schreiben
  //I2CWriteByte(AnalogWert);
  //I2CReadAck();

  // Stopcondition
  //I2C_STOP;
}

/******************************************************************************
I2C_PCF8591Read
Funktion: 	Liest von PCF8591 mit der SlaveNr (0..7) genau  	      *
1 Datenbyte ein (Wert eines AD-Wandlers). Zum Auswhlen des   *
AD-Wandlers mu zuvor ein I2C_PCF8591Write ausgefhrt werden  *
Achtung, bergebener Analogwert stammt von _letzter_ Wandlung, nicht von    *
aktueller!
******************************************************************************/

u08 I2C_PCF8591Read (u08 address ,u08 SlaveNr)
{
  u08 AnalogWert=0x00;
  //Fehlernr = 0;
  
  // Startcondition
  //I2C_START;
  i2c_start();

  // DeviceAdresse ausgeben
  //SlaveAdresse = ((PCF8591<<1) | (SlaveNr<<1) | 0x01);		// Readbit gesetzt
  //I2CWriteByte(SlaveNr);	
  //I2CReadAck();

  // Analogwert einlesen und NACK senden -> kein weiteres Datenbyte einlesen
  //AnalogWert = I2CReadByte();
  //I2CWriteNAck();

  // Stopcondition
  //I2C_STOP;
  
  return AnalogWert;
  
}
