/******************************************************************************
* CAN@home - http://www.CANathome.de - Hausautomation mit AVR + CAN	      *
* Dateiname:		PCF8591.h					      *
* Version:		v1.10						      *
* Datum:		2002-05-17					      *
* 									      *
******************************************************************************/

#ifndef _PCF8591_H_
#define _PCF8591_H_

#define PCF8591		0x48		/* base address (r/w wird nicht einbezogen!) 1-0-0-1-A2-A1-A0 */

// * Defines, die vom Hauptprogramm zum Bilden des ControlBytes genutzt werden knnen
#define PCF8591_CHANNEL0			0x00
#define PCF8591_CHANNEL1			0x01
#define PCF8591_CHANNEL2			0x02
#define PCF8591_CHANNEL3			0x03

#define AUTOINCREMENT				0x04

#define FOUR_SINGLE_ENDED_INPUTS		0x00 /* kann auch entfallen, da sowieso =0 */
#define THREE_DIFFERENTIAL_INPUTS		0x10
#define SINGLE_ENDED_AND_DIFFERENTIAL_MIXED	0x20
#define TWO_DIFFERENTIAL_INPUTS			0x30

#define AOE					0x40
#define ANALOG_OUTPUT_ENABLE			0x40 /* same as AOE */


// ***** Prototypen
extern void I2C_PCF8591Write (u08 address, u08 ControlByte, u08 DAC_Value );	// 2002-05-17
extern u08 I2C_PCF8591Read (u08 address ,u08 ControlByte);						// 2002-05-17

#endif
