/******************************************************************************
* CAN@home - http://www.CANathome.de - Hausautomation mit AVR + CAN	      *
* Dateiname:		can.c						      *
* Version:              v1.11                  				      *
* Funktion:		Unterprogramme fr allg. CAN-Knoten		      *
* 			CANLesen(), CANSchreiben() mit Parameterbergabe      *
* Datum:		2002-04-01					      *
* 									      *
******************************************************************************/

/*#include <io.h>
#include <eeprom.h>
#include <ina90.h>      // 20010728, wg. _NOP()
#include "can.h"
#include "globals.h"    // Globale Variablendefinitionen
#include "DefProjekt.h"	// fr Projektspezifische Definitionen/ Konstanten/ Variablen

#ifdef UPTIME		// wg. Variablen, die fr KnotenInfoLesen-Befehl UPTIME bentigt werden
  #include "timer.h"
#endif

/******************************************************************************
* Initialisierungen 							      *
*									      *
* Funktion: 	- initialisiert SAE81C90				      *
*		- liest ID-Vorbelegung aus EEPROM und kopiert diese in	      *
*		  den CAN-Controller					      *
*									      *
* bergabe Register:	-						      *
* Rckgabe Register:	-						      *
* Verwendete Register:	(temp), daten, adresse, eeadrh, eeadrl		      *
* Vernderte Register:	(temp), daten, adresse, eeadrh, eeadrl		      *
* Aufgerufene Routinen:CANSchreiben					      *
******************************************************************************/
/*void CANInit(void)		//*** Siemens SAE81C90 initialisieren
{
  u08 i, adresse, daten;
  
  CANSchreiben(P0PDR, 0x00);	// Port0 als Eingang definieren
  CANSchreiben(P1LR,  0xFF);	// Port1 mit 0xFF vorbelegen
  CANSchreiben(P1PDR, 0xFF);	// Port1 als Ausgang definieren
  CANSchreiben(MOD,   0x01);	// Umschalten vom Normalmode zum Initialmode
  CANSchreiben(BRPR,  0x3F);	// Baudratenteiler einstellen
  CANSchreiben(BL1,   0x7F);	// Sync, Zeitsegmente, SJW einstellen
  CANSchreiben(BL2,   0x43);	// und RX0 fr Digitalmode vorbereiten
  CANSchreiben(OC,    0x18);	// Ausgang TX0 fr Digitalmode vorbereiten
  CANSchreiben(MOD,   0x00);	// Umschalten vom Initialmode zum Normalmode
  CANSchreiben(INTR,  0x00);	// Interruptregister lschen
  CANSchreiben(IMSK,  0x25);	// verwendete Interrupts freigeben
  CANSchreiben(RRR1,  0x00);	// Receiver-Ready-Register1 lschen
  CANSchreiben(RRR2,  0x00);	// Receiver-Ready-Register2 lschen
  CANSchreiben(RIMR1, 0xFE);	// Alle MO-Interrupts (1-7) zulassen auer MO0 (Sende MO)
  CANSchreiben(RIMR2, 0xFF);	// Alle MO-Interrupts (8-15) zulassen

  // ** CAN-IDs in MOs festlegen (aus EEPROM laden)
  adresse = DR0H;		// Adresse im CAN-Controller fr 
				//  ID-Byte0 MO0 (Zhlvariable)
  for (i=0;i<32;i++)		// 32Bytes vom EEProm in CAN-Controller MO-ID-Bereich kopieren
  {
    while (eeprom_is_ready() == 0) ;	// Warte solange, bis EEProm zugreifbar ist
  
    daten = eeprom_rb ((u16)(EEIDSTART + i));	// Datenbyte vom EEProm einlesen (ab EEIDSTART aufsteigend) (eeprom_rb erwartet als Adresse einen u16-Wert)
    CANSchreiben(adresse, daten);	// gelesenes Datum in CAN-Controller kopieren
    adresse++;				// CAN-Adresse++
  }
}


/******************************************************************************
* Byte zum CAN-Controller schreiben					      *
*									      *
* Funktion: 	- schreibt Byte zum SAE81C90				      *
*		  Die Adressbergabe erfolgt im Register "adresse"	      *
*		  Die Datenbergabe erfolgt im Register "daten"		      *
*		  (Aufhrungsdauer der Routine inkl. Aufruf: ca. 4.7us)	      *
*									      *
* bergabe Register:	adresse, daten					      *
* Rckgabe Register:	-						      *
* Verwendete Register:	temp, daten, adresse				      *
* Vernderte Register:	temp						      *
* Aufgerufene Routinen:-						      *
******************************************************************************/
/*void CANSchreiben (u08 adresse, u08 daten)
{
  cbi (PORTD, CS);		// /CS=0
  sbi (PORTD, ALE);		// ALE=1
  outp(0xFF, DDRB);		// PortB auf Ausgang schalten
  outp(adresse, PORTB);		// <adresse> auf AD0-7 legen
  cbi (PORTD, ALE);		// ALE=0
  cbi (PORTD, WR);		// /WR=0
  outp(daten, PORTB);		// <daten> auf AD0-7 legen
  _NOP();			// Timing (tWLWH) bis zur Datenbernahme
  _NOP();
  sbi (PORTD, WR);		// /WR=1
  outp(0x00, PORTB);		// PortB auf Eingang schalten
  outp(0x00, DDRB);		// PortB Hi-Z
  sbi (PORTD, CS);		// /CS=1
}

/******************************************************************************
* Byte vom CAN-Controller lesen 					      *
*									      *
* Funktion: 	- liest Byte vom SAE81C90 und gibt dies in Register "daten"   *
*		  zurck. Die Adressbergabe erfolgt im Register "adresse"    *
*		  (Aufhrungsdauer der Routine inkl. Aufruf: ca. 4.7us)	      *
*									      *
*									      *
* bergabe Register:	adresse						      *
* Rckgabe Register:	daten						      *
* Verwendete Register:	temp, daten, adresse				      *
* Vernderte Register:	temp, daten					      *
* Aufgerufene Routinen:-						      *
******************************************************************************/
/*u08 CANLesen(u08 adresse)
{
  cbi (PORTD, CS);		// /CS=0
  sbi (PORTD, ALE);		// ALE=1
  outp(0xFF, DDRB);		// PortB auf Ausgang schalten
  outp(adresse, PORTB);		// <adresse> auf AD0-7 legen
  cbi (PORTD, ALE);		// ALE=0
  outp(0x00, PORTB);		// PortB auf Eingang schalten
  outp(0x00, DDRB);		// PortB Hi-Z
  cbi (PORTD, RD);		// /RD=0
  _NOP();			// Timing (tRLDV) bis zur Datengltigkeit
  _NOP();
  daten = inp (PINB);		// Daten von AD0-7 einlesen
  sbi (PORTD, RD);		// /RD=1
  sbi (PORTD, CS);		// /CS=1

  return daten;			// "daten" zurckgeben
}


/******************************************************************************
* ** INTERRUPT-ROUTINE **						      *
* Prfen der MOs auf eingetroffene Telegramme				      *
*									      *
* Funktion: 	Hier wird erkannt, welches MO ein Telegramm empfangen hat und *
*		das entsprechende Unterprogramm gestartet. (Dieses 	      *
*		Unterprogramm wird von der INTERRUPT-Routine aufgerufen)      *
*									      *
*									      *
* bergabe Register:	-						      *
* Rckgabe Register:	-						      *
* Verwendete Register:	temp, merker, adresse, daten			      *
* Vernderte Register:	temp, merker, adresse, daten			      *
* Aufgerufene Routinen:canlesen, canschreiben, MO<n>soft		      *
******************************************************************************/
/*void EMPFANG(void)
{
  daten = CANLesen(RRR1);	// 1.Empfangsregister laden
  merker = daten;

  if ((merker & 0x01) ==  0x01)	// Telegramm auf MO0 eingetroffen?
  {
    MO0soft();
    CANSchreiben(RRR1, ~0x01);	// RRR1-Bit0 wieder lschen; das Schreiben einer "1" hat keine Auswirkung
  }

  if ((merker & 0x02) ==  0x02)	// Telegramm auf MO1 eingetroffen?
  {
    MO1soft();
    CANSchreiben(RRR1, ~0x02);
  }

  if ((merker & 0x04) ==  0x04)	// Telegramm auf MO2 eingetroffen?
  {
    MO2soft();
    CANSchreiben(RRR1, ~0x04);
  }

  if ((merker & 0x08) ==  0x08)	// Telegramm auf MO3 eingetroffen?
  {
    MO3soft();
    CANSchreiben(RRR1, ~0x08);
  }

  if ((merker & 0x10) ==  0x10)	// Telegramm auf MO4 eingetroffen?
  {
    MO4soft();
    CANSchreiben(RRR1, ~0x10);
  }

  if ((merker & 0x20) ==  0x20)	// Telegramm auf MO5 eingetroffen?
  {
    MO5soft();
    CANSchreiben(RRR1, ~0x20);
  }

  if ((merker & 0x40) ==  0x40)	// Telegramm auf MO6 eingetroffen?
  {
    MO6soft();
    CANSchreiben(RRR1, ~0x40);
  }

  if ((merker & 0x80) ==  0x80)	// Telegramm auf MO7 eingetroffen?
  {
    MO7soft();
    CANSchreiben(RRR1, 0x7F);	// ~0x80 bringt: Warning: large integer implicitly truncated to unsigned type
  }

  daten = CANLesen(RRR2);	// 2.Empfangsregister laden
  merker = daten;

  if ((merker & 0x01) ==  0x01)	// Telegramm auf MO8 eingetroffen?
  {
    MO8soft();
    CANSchreiben(RRR2, ~0x01);	// RRR2-Bit0 wieder lschen; das Schreiben einer "1" hat keine Auswirkung
  }

  if ((merker & 0x02) ==  0x02)	// Telegramm auf MO9 eingetroffen?
  {
    MO9soft();
    CANSchreiben(RRR2, ~0x02);
  }

  if ((merker & 0x04) ==  0x04)	// Telegramm auf MO10 eingetroffen?
  {
    MO10soft();
    CANSchreiben(RRR2, ~0x04);
  }

  if ((merker & 0x08) ==  0x08)	// Telegramm auf MO11 eingetroffen?
  {
    MO11soft();
    CANSchreiben(RRR2, ~0x08);
  }

  if ((merker & 0x10) ==  0x10)	// Telegramm auf MO12 eingetroffen?
  {
    MO12soft();
    CANSchreiben(RRR2, ~0x10);
  }

  if ((merker & 0x20) ==  0x20)	// Telegramm auf MO13 eingetroffen?
  {
    MO13soft();
    CANSchreiben(RRR2, ~0x20);
  }

  if ((merker & 0x40) ==  0x40)	// Telegramm auf MO14 eingetroffen?
  {
    MO14soft();
    CANSchreiben(RRR2, ~0x40);
  }

  if ((merker & 0x80) ==  0x80)	// Telegramm auf MO15 eingetroffen?
  {
    MO15soft();
    CANSchreiben(RRR2, 0x7F);	// ~0x80 bringt: Warning: large integer implicitly truncated to unsigned type
  }

  CANSchreiben(INTR, 0xFE);	// ReceiveInterrupt wieder "wegnehmen"; "1" schreiben hat keine Auswirkung
}

/******************************************************************************
* Dekodiert eingetroffene (Konfigurations)Telegramme und startet	      *
* entsprechende Routinen						      *
*									      *
* Funktion: 	- liest die ber MO15 eintreffenden Telegramme und wertet     *
*		  diese aus						      *
*									      *
*									      *
* bergabe Register:	-						      *
* Rckgabe Register:	-						      *
* Verwendete Register:	(temp), daten, adresse, ZH/ZL			      *
* Vernderte Register:	(temp), daten, adresse, ZH/ZL			      *
* Aufgerufene Routinen:canlesen, canschreiben	 			      *
******************************************************************************/
/*void KnotenBefehl(void)
{
  u16 eeadr;
  
  daten = CANLesen(MO15B7);	// MO15B7 lesen (wg. shadowRegister aktualisieren) und verwerfen
  daten = CANLesen(MO15B0);	// MO15B0 lesen (=Knotenbefehl)

  if (daten == kbefehl1)		// Knotenbefehl <kbefehl1> erkannt?
  {
    // ** FernEEProm lesen
    // * MO0 (SendeMO) frei? 
    while ((CANLesen(TRSR1) & 0x01) == 0x01) ;	// Warte, bis anstehendes (altes) Paket abgeschickt wurde
    
    CANSchreiben(DR0H, CANLesen(MO15B1));	// AntwortID-high lesen und nach DR0H schreiben
    CANSchreiben(DR0L, CANLesen(MO15B2));	// AntwortID-low lesen und nach DR0L schreiben
    
    eeadr = (u16)((CANLesen(MO15B3)) * 256);	// EEProm-Adresse-High lesen und in eeadr einlagern
    CANSchreiben(MO0B3, CANLesen(MO15B3));	// nach MO0B3 kopieren
    
    eeadr += (u16)(CANLesen(MO15B4));		// EEProm-Adresse-Low lesen und in eeadr einlagern
    CANSchreiben(MO0B4, CANLesen(MO15B4));	// nach MO0B4 umkopieren

    while (eeprom_is_ready() == 0) ;		// Warte solange, bis EEProm zugreifbar ist
    CANSchreiben(MO0B5, eeprom_rb(eeadr));	// Datenbyte vom EEProm einlesen und nach MO0B5 kopieren
    						//  eeprom_rb erwartet als Adresse einen u16-Wert
    
    CANSchreiben(MO0B1, CANLesen(DR15H));	// DR15H (=lokales IDByteHigh) lesen und nach MO0B1 kopieren
    CANSchreiben(MO0B2, CANLesen(DR15L));	// DR15L (=lokales IDByteLow)  lesen und nach MO0B2 schreiben
    CANSchreiben(MO0B0, kbefehl1);		// Befehlskennung <kbefehl1> nach MO0B0 schreiben (und damit auch shadowRegister auf Datenbereich von MO0 kopieren)
    
    // ** Paket abschicken
    CANSchreiben(TRSR1, 0x01);
  }
  
  if (daten == kbefehl2)		// Knotenbefehl <kbefehl2> erkannt?
  {
    // ** FernEEPROM schreiben
    // * MO0 frei?
    while ((CANLesen(TRSR1) & 0x01) == 0x01) ;		// Warte, bis anstehendes (altes) Paket abgeschickt wurde

    CANSchreiben(DR0H, CANLesen(MO15B1));	// AntwortID-high lesen und nach DR0H schreiben
    CANSchreiben(DR0L, CANLesen(MO15B2));	// AntwortID-low  lesen und nach DR0L schreiben

    eeadr = (u16)(CANLesen(MO15B3) * 256);		// EEProm-Adresse-High lesen in eeadr einlagern
    CANSchreiben(MO0B3, CANLesen(MO15B3));		//  und nach MO0B3 kopieren
    
    //			;* Byte 3, 4 und 5 im shadowRegister sollen 
    //			;  erhalten bleiben und mssen daher nicht umkopiert
    //			;  werden.

    eeadr += (u16)(CANLesen(MO15B4));		// EEProm-Adresse-Low lesen in eeadr einlagern
    CANSchreiben(MO0B4, CANLesen(MO15B4));	// nach MO0B4 umkopieren

    while (eeprom_is_ready() == 0) ;	// Warte solange, bis EEProm zugreifbar ist
    eeprom_wb (eeadr, CANLesen(MO15B5));	// Datenbyte (MO15B5) ins EEProm schreiben (eeprom_wb erwartet als Adresse einen u16-Wert)

    CANSchreiben(MO0B1, CANLesen(DR15H));	// DR15H (=lokales IDByteHigh) lesen und nach MO0B1 kopieren
    CANSchreiben(MO0B2, CANLesen(DR15L));	// DR15L (=loklaes IDByteLow) lesen und nach MO0B2 schreiben
    
    CANSchreiben(MO0B0, kbefehl2);	// Befehlskennung <kbefehl2> nach MO0B0 schreiben (und damit auch shadowRegister auf Datenbereich von MO0 kopieren)
    
    // ** Paket abschicken
    CANSchreiben(TRSR1, 0x01);
  }

  if (daten == kbefehl3)		// Knotenbefehl <kbefehl3> erkannt?
  {
    // ** FernCANRegister lesen
    // * MO0 (SendeMO) frei? 
    while ((CANLesen(TRSR1) & 0x01) == 0x01) ;		// Warte, bis anstehendes (altes) Paket abgeschickt wurde

    CANSchreiben(DR0H, CANLesen(MO15B1));	// AntwortID-high lesen und nach DR0H schreiben
    CANSchreiben(DR0L, CANLesen(MO15B2));	// AntwortID-low  lesen und nach DR0L schreiben

    CANSchreiben(MO0B3, CANLesen(MO15B3));	// CANRegister-Adresse lesen (Byte 3) und in MO0B3 schreiben

    // CANRegister-Adresse lesen (MO15B3), hier steht die CAN-Controller Registeradresse, die gelesen werden soll
    //  dann vom CAN-Controller auslesen, und den Inhalt des CANRegisters nach MO0B4 schreiben
    CANSchreiben(MO0B4, CANLesen(CANLesen(MO15B3)));

    CANSchreiben(MO0B1, CANLesen(DR15H));	// DR15H (=lokales IDByteHigh) lesen und nach MO0B1 kopieren
    CANSchreiben(MO0B2, CANLesen(DR15L));	// DR15L (=loklaes IDByteLow) lesen und nach MO0B2 schreiben
    
    CANSchreiben(MO0B0, kbefehl3);	// Befehlskennung <kbefehl3> nach MO0B0 schreiben (und damit auch shadowRegister auf Datenbereich von MO0 kopieren)

    // ** Paket abschicken
    CANSchreiben(TRSR1, 0x01);
  }
  
  if (daten == kbefehl4)		// Knotenbefehl <kbefehl4> erkannt?
  {
    // ** FernCANRegister schreiben
    // * MO0 frei?
    while ((CANLesen(TRSR1) & 0x01) == 0x01) ;		// Warte, bis anstehendes (altes) Paket abgeschickt wurde

    CANSchreiben(DR0H, CANLesen(MO15B1));	// AntwortID-high lesen und nach DR0H schreiben
    CANSchreiben(DR0L, CANLesen(MO15B2));	// AntwortID-low  lesen und nach DR0L schreiben

    // zu schreibende CANRegister-Adresse lesen (MO15B3), zu schreibendes Datum lesen
    //  dann Datum an gelesene Adresse schreiben 
    CANSchreiben(CANLesen(MO15B3), CANLesen(MO15B4));

    CANSchreiben(MO0B1, CANLesen(DR15H));	// DR15H (=lokales IDByteHigh) lesen und nach MO0B1 kopieren
    CANSchreiben(MO0B2, CANLesen(DR15L));	// DR15L (=loklaes IDByteLow) lesen und nach MO0B2 schreiben
    
    CANSchreiben(MO0B0, kbefehl4);	// Befehlskennung <kbefehl4> nach MO0B0 schreiben (und damit auch shadowRegister auf Datenbereich von MO0 kopieren)

    // ** Paket abschicken
    CANSchreiben(TRSR1, 0x01);
  }

  if (daten == kbefehl5)		// Knotenbefehl <kbefehl5> erkannt?
  {
    // nicht implementiert, wird nicht gebraucht!
  }
  
  if (daten == kbefehl6)		// Knotenbefehl <kbefehl6> erkannt?
  {
    // nicht implementiert, wird nicht gebraucht!    
  }

  if (daten == kbefehl7)		// Knotenbefehl <kbefehl7> erkannt?
  {
    // ** KnotenInfo lesen
    // * MO0 (SendeMO) frei? 
    while ((CANLesen(TRSR1) & 0x01) == 0x01) ;		// Warte, bis anstehendes (altes) Paket abgeschickt wurde

    CANSchreiben(DR0H, CANLesen(MO15B1));	// AntwortID-high lesen und nach DR0H schreiben
    CANSchreiben(DR0L, CANLesen(MO15B2));	// AntwortID-low  lesen und nach DR0L schreiben

    CANSchreiben(MO0B3, CANLesen(MO15B3));	// KnotenInfoIndex lesen (Byte 3) und in MO0B3 schreiben

    switch (CANLesen(MO15B3))
    {
      case 0: // Softwaretyp
      {
        CANSchreiben(MO0B4, Softwaretyp1);
        CANSchreiben(MO0B5, Softwaretyp2);
        CANSchreiben(MO0B6, Softwaretyp3);
        CANSchreiben(MO0B7, Softwaretyp4);
        break;
      }
      case 1: // Softwareversionskennung
      {
        CANSchreiben(MO0B4, Softwareversionskennung1);
        CANSchreiben(MO0B5, Softwareversionskennung2);
        CANSchreiben(MO0B6, Softwareversionskennung3);
        CANSchreiben(MO0B7, Softwareversionskennung4);
        break;
      }
      case 2: // Externe EEProm Groesse
      {
        CANSchreiben(MO0B4, (eEEPromSize>>8));
        CANSchreiben(MO0B5, (eEEPromSize&0x00FF));
        break;
      }
      #ifdef UPTIME
      case 3: // Uptime abfragen
      {
        CANSchreiben(MO0B4, Minuten);
        CANSchreiben(MO0B5, Stunden);
        CANSchreiben(MO0B6, (u08)(Tage>>8));	// obere 8Bit
        CANSchreiben(MO0B7, (u08)(Tage));	// untere 8Bit
        break;
      }
      #endif
      default: // Info nicht verfgbar
      {
      	CANSchreiben(MO0B4, 0x00);
        CANSchreiben(MO0B5, 0x00);
        CANSchreiben(MO0B6, 0x00);
        CANSchreiben(MO0B7, 0x00);
        break;
      }
    }

    
    CANSchreiben(MO0B1, CANLesen(DR15H));	// DR15H (=lokales IDByteHigh) lesen und nach MO0B1 kopieren
    CANSchreiben(MO0B2, CANLesen(DR15L));	// DR15L (=loklaes IDByteLow) lesen und nach MO0B2 schreiben
    
    CANSchreiben(MO0B0, kbefehl7);	// Befehlskennung <kbefehl7> nach MO0B0 schreiben (und damit auch shadowRegister auf Datenbereich von MO0 kopieren)

    // ** Paket abschicken
    CANSchreiben(TRSR1, 0x01);
    
  }
  
}

