/******************************************************************************
* CAN@home - http://www.CANathome.de - Hausautomation mit AVR + CAN	      *
* Dateiname:		can.h						      *
* Version:		v1.11						      *
* Datum:		2002-04-01					      *
* 									      *
******************************************************************************/

#ifndef _CAN_H_
#define _CAN_H_

// ***** Prototypen
extern void CANInit(void);      					//20010728
extern unsigned char CANLesen(unsigned char adresse);			//20010728
extern void CANSchreiben (unsigned char adresse, unsigned char daten);	//20010728
extern void EMPFANG(void);      //20010728
extern void KnotenBefehl(void); //20010728

extern void MO0soft(void);	//20010728
extern void MO1soft(void);	//20010728
extern void MO2soft(void);	//20010728
extern void MO3soft(void);	//20010728
extern void MO4soft(void);	//20010728
extern void MO5soft(void);	//20010728
extern void MO6soft(void);	//20010728
extern void MO7soft(void);	//20010728
extern void MO8soft(void);	//20010728
extern void MO9soft(void);	//20010728
extern void MO10soft(void);	//20010728
extern void MO11soft(void);	//20010728
extern void MO12soft(void);	//20010728
extern void MO13soft(void);	//20010728
extern void MO14soft(void);	//20010728
extern void MO15soft(void);	//20010728


// ***** Konstantendefinitionen
#define	EEIDSTARTH  0		// Startadresse im EEProm fr MO-ID-Belegung
#define EEIDSTARTL  4
#define EEIDSTART   4           // Startadresse im EEProm (als 16Bit-Wert) fr
				//  MO-ID-Belegung

//** AD Symbole
#define ALE	 4
#define	CS 	 5
#define WR	 6
#define	RD	 7

//** Knotenbefehlskonstanten
#define	kbefehl1  '1'
#define	kbefehl2  '2'
#define	kbefehl3  '3'
#define	kbefehl4  '4'
#define	kbefehl5  '5'
#define	kbefehl6  '6'
#define	kbefehl7  '7'



//***** CAN Adressen (lt. Datenblatt Siemens SAE81C90) *****
#define	BL1	0x00
#define	BL2	0x01
#define	OC	0x02
#define	BRPR	0x03
#define	RRR1	0x04
#define	RRR2	0x05
#define	RIMR1	0x06
#define	RIMR2	0x07
#define	TRSR1	0x08
#define	TRSR2	0x09
#define	IMSK	0x0a

#define	MOD	0x10
#define	INTR	0x11
#define	CTRL	0x12

#define	CCR 	0x14
#define	TCEC	0x15
#define	TCD	0x16

#define	TRRR1	0x18
#define	TRRR2	0x19
#define	RRP1R	0x1a
#define	RRP2R	0x1b
#define	TSCH	0x1c
#define	TSCL	0x1d

#define	P0PDR	0x28
#define	P0PR	0x29
#define	P0LR	0x2a

#define	P1PDR	0x2c
#define	P1PR	0x2d
#define	P1LR	0x2e

#define	TSR0H	0x30
#define	TSR0L	0x31
#define	TSR1H	0x32
#define	TSR1L	0x33
#define	TSR2H	0x34
#define	TSR2L	0x35
#define	TSR3H	0x36
#define	TSR3L	0x37
#define	TSR4H	0x38
#define	TSR4L	0x39
#define	TSR5H	0x3a
#define	TSR5L	0x3b
#define	TSR6H	0x3c
#define	TSR6L	0x3d
#define	TSR7H	0x3e
#define	TSR7L	0x3f

#define	DR0H	0x40
#define	DR0L	0x41
#define	DR1H	0x42
#define	DR1L	0x43
#define	DR2H	0x44
#define	DR2L	0x45
#define	DR3H	0x46
#define	DR3L	0x47
#define	DR4H	0x48
#define	DR4L	0x49
#define	DR5H	0x4a
#define	DR5L	0x4b
#define	DR6H	0x4c
#define	DR6L	0x4d
#define	DR7H	0x4e
#define	DR7L	0x4f

#define	DR8H	0x50
#define	DR8L	0x51
#define	DR9H	0x52
#define	DR9L	0x53
#define	DR10H	0x54
#define	DR10L	0x55
#define	DR11H	0x56
#define	DR11L	0x57
#define	DR12H	0x58
#define	DR12L	0x59
#define	DR13H	0x5a
#define	DR13L	0x5b
#define	DR14H	0x5c
#define	DR14L	0x5d
#define	DR15H	0x5e
#define	DR15L	0x5f

#define	MO0B0	0x80
#define	MO0B1	0x81
#define	MO0B2	0x82
#define	MO0B3	0x83
#define	MO0B4	0x84
#define	MO0B5	0x85
#define	MO0B6	0x86
#define	MO0B7	0x87

#define	MO1B0	0x88
#define	MO1B1	0x89
#define	MO1B2	0x8a
#define	MO1B3	0x8b
#define	MO1B4	0x8c
#define	MO1B5	0x8d
#define	MO1B6	0x8e
#define	MO1B7	0x8f

#define	MO2B0	0x90
#define	MO2B1	0x91
#define	MO2B2	0x92
#define	MO2B3	0x93
#define	MO2B4	0x94
#define	MO2B5	0x95
#define	MO2B6	0x96
#define	MO2B7	0x97

#define	MO3B0	0x98
#define	MO3B1	0x99
#define	MO3B2	0x9a
#define	MO3B3	0x9b
#define	MO3B4	0x9c
#define	MO3B5	0x9d
#define	MO3B6	0x9e
#define	MO3B7	0x9f

#define	MO4B0	0xa0
#define	MO4B1	0xa1
#define	MO4B2	0xa2
#define	MO4B3	0xa3
#define	MO4B4	0xa4
#define	MO4B5	0xa5
#define	MO4B6	0xa6
#define	MO4B7	0xa7

#define	MO5B0	0xa8
#define	MO5B1	0xa9
#define	MO5B2	0xaa
#define	MO5B3	0xab
#define	MO5B4	0xac
#define	MO5B5	0xad
#define	MO5B6	0xae
#define	MO5B7	0xaf

#define	MO6B0	0xb0
#define	MO6B1	0xb1
#define	MO6B2	0xb2
#define	MO6B3	0xb3
#define	MO6B4	0xb4
#define	MO6B5	0xb5
#define	MO6B6	0xb6
#define	MO6B7	0xb7

#define	MO7B0	0xb8
#define	MO7B1	0xb9
#define	MO7B2	0xba
#define	MO7B3	0xbb
#define	MO7B4	0xbc
#define	MO7B5	0xbd
#define	MO7B6	0xbe
#define	MO7B7	0xbf

#define	MO8B0	0xc0
#define	MO8B1	0xc1
#define	MO8B2	0xc2
#define	MO8B3	0xc3
#define	MO8B4	0xc4
#define	MO8B5	0xc5
#define	MO8B6	0xc6
#define	MO8B7	0xc7

#define	MO9B0	0xc8
#define	MO9B1	0xc9
#define	MO9B2	0xca
#define	MO9B3	0xcb
#define	MO9B4	0xcc
#define	MO9B5	0xcd
#define	MO9B6	0xce
#define	MO9B7	0xcf

#define	MO10B0	0xd0
#define	MO10B1	0xd1
#define	MO10B2	0xd2
#define	MO10B3	0xd3
#define	MO10B4	0xd4
#define	MO10B5	0xd5
#define	MO10B6	0xd6
#define	MO10B7	0xd7

#define	MO11B0	0xd8
#define	MO11B1	0xd9
#define	MO11B2	0xda
#define	MO11B3	0xdb
#define	MO11B4	0xdc
#define	MO11B5	0xdd
#define	MO11B6	0xde
#define	MO11B7	0xdf

#define	MO12B0	0xe0
#define	MO12B1	0xe1
#define	MO12B2	0xe2
#define	MO12B3	0xe3
#define	MO12B4	0xe4
#define	MO12B5	0xe5
#define	MO12B6	0xe6
#define	MO12B7	0xe7

#define	MO13B0	0xe8
#define	MO13B1	0xe9
#define	MO13B2	0xea
#define	MO13B3	0xeb
#define	MO13B4	0xec
#define	MO13B5	0xed
#define	MO13B6	0xee
#define	MO13B7	0xef

#define	MO14B0	0xf0
#define	MO14B1	0xf1
#define	MO14B2	0xf2
#define	MO14B3	0xf3
#define	MO14B4	0xf4
#define	MO14B5	0xf5
#define	MO14B6	0xf6
#define	MO14B7	0xf7

#define	MO15B0	0xf8
#define	MO15B1	0xf9
#define	MO15B2	0xfa
#define	MO15B3	0xfb
#define	MO15B4	0xfc
#define	MO15B5	0xfd
#define	MO15B6	0xfe
#define	MO15B7	0xff


#endif
