//#include "i2cmaster.h"
//#include "PCF8591.h"

// define the data direction in i2c_start(),i2c_rep_start() 
void i2c_init(void) //0
{
 TWCR= 0x00; //disable twi
 //TWBR= 0x01; //set bit rate 222000Hz
 //TWBR= 0x1E; //48,5 kHz
 TWBR= 0x04; //set bit rate 83,333kHz
 TWAR= 0x72; //set slave address A2=0, A1=0, A0=1 the chip address is 0xb0111(A2)(A1)(A0)=7bits
 TWCR= 0x45; //enable twi
 //TWCR|= (1<<TWEA)|(1<<TWEN)|(1<<TWIE);//TWEA-Enable Acknowledge
}
// @brief Issues a start condition and sends address and transfer direction 
// @param    addr address and transfer direction of I2C device

void i2c_start(void) //1
{TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN); //make start	
 while (!(TWCR & (1<<TWINT))); //wait until start done	
 if ((TWSR & 0xF8) != START) {ERROR("startB");} // check start
}
void i2c_rep_start(void) //1
{TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN); //make start	
 //TWCR = (1<<TWSTA); //make start	
 //while (!(TWCR & (1<<TWINT))); //wait until start done	
 //if ((TWSR & 0xF8) != START) {ERROR("startB");} // check start
}
void i2c_WR(u08 address,u08 value)
  {i2c_start();
   i2c_WR_byte((address<<1));//send address
   if ((TWSR & 0xF8) != MT_SLA_ACK){sprintf(s, "TWSR%X",(TWSR & 0xF8));ERROR(&s[0]);} //if not ACK not received then ...
   i2c_WR_byte(value);//send data to write modus
   if ((TWSR & 0xF8) != DAT_TX_ACK_RX){sprintf(s, "TWSR%X",(TWSR & 0xF8));ERROR(&s[0]);} //if not ACK not received then ...
   i2c_stop();
  }
void i2c_WR_2Bytes(u08 address,u08 value1, u08 value2)
  {i2c_start();
   i2c_WR_byte((address<<1));//send address
   if ((TWSR & 0xF8) != MT_SLA_ACK){sprintf(s, "TWSR%X",(TWSR & 0xF8));ERROR(&s[0]);} //if not ACK not received then ...
   i2c_WR_byte(value1);//send data to write modus
   if ((TWSR & 0xF8) != DAT_TX_ACK_RX){sprintf(s, "TWSR%X",(TWSR & 0xF8));ERROR(&s[0]);} //if not ACK not received then ...
   i2c_WR_byte(value2);//send data to write modus
   //if ((TWSR & 0xF8) != DAT_TX_ACK_RX){sprintf(s, "TWSR%X",(TWSR & 0xF8));ERROR(&s[0]);} //if not ACK not received then ...
   i2c_stop();
  }
  
u08 i2c_RD(u08 address)
  {u08 ret_value;
   i2c_start();
   i2c_WR_byte((address<<1)|0x01);//send address to read modus
   ret_value=i2c_RD_byteNak();//send data
   i2c_stop();
   return ret_value;
  }  
 u08 i2c_RD_2Bytes(u08 address)
  {u08 ret_value,ret_value_2;
   i2c_start();
   i2c_WR_byte((address<<1)|0x01);//send address to read modus
   ret_value=i2c_RD_byteAck();//send data
   delus(2);
   ret_value_2=i2c_RD_byteNak();
   i2c_stop();
   return ret_value;
  }  

// @brief Issues a start condition and sends address and transfer direction  
// If device is busy, use ack polling to wait until device ready 
void i2c_start_wait(unsigned char addr)
{
}
// @brief Send one byte to I2C device
void i2c_WR_byte(unsigned char data)
{
 TWDR = data;
 TWCR = (1<<TWINT) | (1<<TWEN); //Load DATA into TWDR Register. Clear TWINT bit in TWCR to start transmission of data
 while (!(TWCR & (1<<TWINT))); 
 }
 
 u08 i2c_RD_byteAck(void)
 {TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWEA); //Load DATA into TWDR Register. Clear TWINT bit in TWCR to start transmission of data
  while (!(TWCR & (1<<TWINT))); 
  //if ((TWSR & 0xF8) != DAT_TX_ACK_RX){sprintf(s, "er%X",(TWSR & 0xF8));ERROR(&s[0]);}
  return TWDR;
 }
 
u08 i2c_RD_byteNak(void)
{TWCR |= (1<<TWINT); //start reading by setting TWINT to 1 (clear TWINT)
 while (!(TWCR & (1<<TWINT)));
 return TWDR;
}
 
void i2c_stop(void)//@brief Terminates the data transfer and releases the I2C bus
{
 TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
} 

void ERROR(char *what)
 {lcd_WR_string(LCD_Line_1,what);
  delms(30);
 }


u08 i2c_LM75_TemperRead (u08 address)
{unsigned int u16_temperature=0;
 u08 value_0,value_1; float f_temperat;
 /*
 i2c_start();
 i2c_WR_byte((address<<1));//send address to wr modus
 i2c_WR_byte(0x00);//for ready the temperature register
 i2c_stop();
 delus(6);
 */
 i2c_start();
 i2c_WR_byte((address<<1)|0x01);//send address to rd modus
 
 value_0=i2c_RD_byteAck();
 //value_0<<=1;
 value_1=i2c_RD_byteNak();
 //value_1>>=7;
 //value_0|=value_1;
 i2c_stop();
 
 sprintf(s, "\r\nTemp:___%d", value_0); uart_printstr( &s[0]);
 sprintf(s, "\r\nTemp_0,5:___%d\r\n", value_1); uart_printstr( &s[0]);
 
 //sprintf(s, "Temperat/2=%d",value_0);
 //lcd_WR_string(LCD_L3,&s[0]);
 //f_temperat=(float)value_0;
 //sprintf(s, "f%-%d",f_temperat);
 //lcd_WR_string(LCD_L4,&s[0]);
 //f_temperat/=2;
 //temperature.temperature_value=ret_value;
 //return temperature.temperature_value;
 return value_0;
}

void I2C_PCF8591Write (u08 address, u08 ControlByte, u08 DAC_Value)
{i2c_start();
 i2c_WR_byte((address<<1));//send address
 //if ((TWSR & 0xF8) != MT_SLA_ACK){sprintf(s, "TWSR1%X",(TWSR & 0xF8));ERROR(&s[0]);} //if not ACK not received then ...
 i2c_WR_byte(ControlByte);//send ControlByte
 i2c_WR_byte(DAC_Value);//send data to write modus
 i2c_stop();

}

/******************************************************************************
I2C_PCF8591Read
******************************************************************************/
u08 I2C_PCF8591Read (u08 address ,u08 ControlByte)
{u08 ret_value;
 i2c_start();
 i2c_WR_byte((address<<1)|0x01);//send address to read modus
 //i2c_WR_byte(ControlByte);//send address to read modus
 ret_value=i2c_RD_byteNak();//send data
 i2c_stop();
 return ret_value; 
  
}

void i2c_PCF8573_TimeRD (u08 address)
{
 i2c_WR(address,EXEC_ADDR | TIME_HOUR); 
 time.hour=BCD_to_char(i2c_RD(address));
 i2c_WR(address,EXEC_ADDR | TIME_MINUTE); 
 time.minute=BCD_to_char(i2c_RD(address));
 
 i2c_WR(address,EXEC_ADDR | TIME_DAY); 
 time.day=BCD_to_char(i2c_RD(address));
 i2c_WR(address,EXEC_ADDR | TIME_MONTH); 
 time.month=BCD_to_char(i2c_RD(address));
}

void i2c_PCF8573_AlarmRD (u08 address)
{
 i2c_WR(address,EXEC_ADDR | ALARM_HOUR); 
 time.hour=BCD_to_char(i2c_RD(address));
 i2c_WR(address,EXEC_ADDR | ALARM_MINUTE); 
 time.minute=BCD_to_char(i2c_RD(address));
 
 i2c_WR(address,EXEC_ADDR | ALARM_DAY); 
 time.day=BCD_to_char(i2c_RD(address));
 i2c_WR(address,EXEC_ADDR | ALARM_MONTH); 
 time.month=BCD_to_char(i2c_RD(address));
}

 