/************************************************************************* 
* Title:    C include file for the I2C master interface (i2cmaster.S)
* Author:   
* File:     
* Software: 
* Target:   
* Usage:    
**************************************************************************/
//#ifndef _I2CMASTER_H
//#define _I2CMASTER_H   1

#define i2cKPaddr 0x38 //011 1 000 
#define i2cLCDaddr 0x39 //011 1 001        
#define i2cPortA 0x3A //011 1 010
#define i2cPortB 0x3B //011 1 011
#define i2cPowerCard 0x3C //011 1 100
#define i2cAnaPortA 0x48 //100 1 000 base address  1-0-0-1-A2-A1-A0 
#define i2cRTC 0x68 //110 1 000 base address  1-1-0-1-0-A1-A0 
#define i2cTemper 0x49 //100 1 001 base address  1-0-0-1-A2-A1-A0 

#define i2cADCaddr 0x3B //011 1 011

//#define i2cLCDaddr 0x39 //        -->1   
//#define i2cKPaddr 0x3A //0111 010 -->0
//#define i2cADCaddr 0x3B //0111 011
//#define i2cPortA 0x3C //0111 100
//#define i2cPortB 0x3D //0111 101
//#define i2cAnaPortA 0x48 //1001 000 base address  1-0-0-1-A2-A1-A0 

//For LM 75
#define TemperatureRead 0x00
#define Configuration 0x01
#define T_hyst 0x10
#define T_os 0x11

#define i2c_read(ack)  (ack) ? i2c_readAck() : i2c_readNak();
#define START 0x08
#define START_rep 0x10
#define MT_SLA_ACK 0x18  //Slave address accepted
#define SLA_W_NACK 0x20
#define DAT_TX_ACK_RX 0x28 //Data sent acknoledged by slave
#define DAT_TX_NACK_RX 0x30
#define ARBIT_LOST 0x38
#define I2C_READ    1
#define I2C_WRITE   0
#include <iom32v.h>

#include "PCF8591.h"
#include "PCF8573.h"

void i2c_init(void);
void i2c_WR(u08 address,u08 value);
void i2c_WR_2Bytes(u08 address,u08 value1, u08 value2);
u08 i2c_RD(u08 address);
u08 i2c_RD_2Bytes(u08 address);
void i2c_start(void);
void i2c_rep_start(void);
void i2c_stop(void);
void i2c_WR_byte(unsigned char data);
u08 i2c_RD_byteNak(void);
u08 i2c_RD_byteAck(void);
u08 i2c_written; 
void ERROR(char *what);
u08 i2c_LM75_TemperRead (u08 address);
void i2c_PCF8573_TimeRD (u08 address);
void i2c_PCF8573_AlarmRD (u08 address);


 
