#define SETBIT(port,bit_no)	(port |=(1<<bit_no))
#define sbi(port,bit_no)	(port |=(1<<bit_no))
#define CLEARBIT(port,bit_no)	(port &=~(1<<bit_no))
#define cbi(port,bit_no)	(port &=~(1<<bit_no))
#define CHECKBIT(port,bit_no)	(port &(1<<bit_no))
#define checkbit_1(port,bit_no)	(port &(1<<bit_no))
#define CHECKBIT_FOR_ZERO(port,bit_no)	((~port) &(1<<bit_no))
#define checkbit_0(port,bit_no)	((~port) &(1<<bit_no))
#define TOGGLEBIT(port,bit_no)	(port ^=(1<<bit_no))
#define tbi(port,bit_no)	(port ^=(1<<bit_no))
#define outp(source,destination) (destination = source)

#define UP '2'
#define DOWN '8'
#define NEXT '6'
#define PREV '4' 
#define OK '*'
#define ESC '#'

#define FIRST_OP_MENUE 7


//#define i2cLCDaddr 0x39
//#define i2cKPaddr 0x3A //0111 010
//#define i2cADCaddr 0x3B //0111 011
//#define i2cPortA 0x3C //0111 100
//#define i2cPortB 0x3D //0111 101

typedef struct{
  unsigned char *text;
  unsigned char previous;
  unsigned char next;
  unsigned char up;
  unsigned char down;
  void (*pToFunction)(void);
} menuStruct;

#include "CAN_functions.h"

void sysTimer(void);
u08 findSettedBitNumberOfByte(u08 givenByte);
void clear_string(char *p_str);
void delms(int ms);
void delus(int us);
void write_Bit_Port_toPort(unsigned char bit_no,volatile unsigned char port_from,volatile unsigned char port_to );
void write_Bit_Port_to_Bit_Port(unsigned char bit_no_from,  unsigned char port_from,unsigned char bit_no_to,  unsigned char port_to );
void intro(void);
void SetBits(void);
void menu0(void);
void doNothing(void);
void menuView(void);
void menuGuide(void);
void SetBits(void);
u08 wait_for_key(void);
void readFromPCF8591(void);
void ShowTemerature(void);
void ShowTemerature_i2c(void);
void ShowTime_i2c(void);
void ShowAlarm_i2c(void);
u08 BCD_to_char (u08 BCD);
u08 char_to_BCD (u08 given_char);
void lcd_i2c_print_time(void);
void SetupThermostat(void);
void SetClock(void);
void SetAlarm(void);
void SetupVariable(char *pTo);
void WR_time_to_EEPROM(void);
void findAddress_next_op_time(char *pTo);
void beep(void);
void Door(void);
void automatic(void);
void manuell(void);
void set_T_hyst(void);

const menuStruct menu[] = {
 //                  pr  nxt up down func
  {" ***Menue***   ", 5 , 1 , 0 , 0, doNothing         }, //0
  {" Betrieb       ", 0 , 2 , 0 , 6, doNothing         }, //1
  {" Einstell.     ", 1 , 3 , 0 , 14, doNothing        }, //2
  {" Reserve 1     ", 2 , 4 , 0 , 20, doNothing        }, //3
  {" Reserve 2     ", 3 , 5 , 0 , 26, doNothing        }, //4
  {" Reserve 3     ", 4 , 1 , 0 , 32, doNothing        }, //5
  //Betrieb  
  {" Auto          ", 13, 7 , 1 , 0, automatic         }, //6
  {" Hand          ", 6 , 8 , 1 , 0, manuell           }, //7
  {" keine Funkt.  ", 7 , 9 , 1 , 0, doNothing         }, //8
  {" keine Funkt.  ", 8 , 10, 1 , 0, doNothing		   }, //9
  {" keine Funkt.  ", 9 , 11, 1 , 0, doNothing         }, //10
  {" keine Funkt.  ", 10, 12, 1 , 0, doNothing         }, //11
  {" keine Funkt.  ", 11, 13, 1 , 0, doNothing         }, //12
  {" keine Funkt.  ", 12, 6 , 1 , 0, doNothing         }, //13
  //Einstel.
  {" Set Clock     ", 19, 15, 2 , 0, SetClock          }, //14
  {" Set T-hyst    ", 14, 16, 2 , 0, set_T_hyst        }, //15
  {" keine Funkt.  ", 15, 17, 2 , 0, doNothing         }, //16
  {" keine Funkt.  ", 16, 18, 2 , 0, doNothing         }, //17
  {" keine Funkt.  ", 17, 19, 2 , 0, doNothing         }, //18
  {" keine Funkt.  ", 18, 14, 2 , 0, doNothing         }, //19
  //Reserve 1
  {" keine Funkt.  ", 25, 21, 3 , 0, doNothing         }, //20
  {" keine Funkt.  ", 20, 22, 3 , 0, doNothing		   }, //21
  {" keine Funkt.  ", 21, 23, 3 , 0, doNothing         }, //22
  {" keine Funkt.  ", 22, 24, 3 , 0, doNothing         }, //23
  {" keine Funkt.  ", 23, 25, 3 , 0, doNothing         }, //24
  {" keine Funkt.  ", 24, 20, 3 , 0, doNothing         }, //25
  //Com
  {" keine Funkt.  ", 31, 27, 4 , 0, doNothing         }, //26
  {" keine Funkt.  ", 26, 28, 4 , 0, doNothing         }, //27
  {" keine Funkt.  ", 27, 29, 4 , 0, doNothing         }, //28
  {" keine Funkt.  ", 28, 30, 4 , 0, doNothing         }, //29
  {" keine Funkt.  ", 29, 31, 4 , 0, doNothing         }, //30
  {" keine Funkt.  ", 30, 26, 4 , 0, doNothing         }, //31
  //Reserve 2
  {" keine Funkt.  ", 37, 33, 5 , 0, doNothing         }, //32
  {" keine Funkt.  ", 32, 34, 5 , 0, doNothing         }, //33
  {" keine Funkt.  ", 33, 35, 5 , 0, doNothing         }, //34
  {" keine Funkt.  ", 34, 36, 5 , 0, doNothing         }, //35
  {" keine Funkt.  ", 35, 37, 5 , 0, doNothing         }, //36
  {" keine Funkt.  ", 36, 38, 5 , 0, doNothing         }, //37
  
};  
    



