
#include <iom32v.h> 
#include "ramconnect.h"

#define PORT_RAM_OUT PORTA /* The port on which is the RAM conected */
#define PORT_RAM_IN PINA /* The address of the in port form the RAM */
#define PORT_RAM_CONTROL DDRA /* The controlregister of the port to the RAM*/
#define CONTROL_RAM_DDR DDRB /* WR, RD and ALE PORT */
#define RD_RAM PINB7 /* The pin to the not(RD) to the RAM */
#define PORT_RD PORTB /* Port to the RD_RAM */
#define WR_RAM PINB6 /* The pin to the not(WR) to the RAM */
#define PORT_WR PORTB /* Port to the WR_RAM */
#define ALE_RAM PINB5 /* The pin to the ALE to the RAM */
#define PORT_ALE PORTB /* Port to the ALE_RAM */

void init_ramconnect() 
{outp((1<<RD_RAM) | (1<<WR_RAM) | (1<<ALE_RAM), CONTROL_RAM_DDR);
}
void WR(u08 Address, u08 Value) //Write to the RAM
{
 sbi(PORT_RD,RD_RAM); //set not(RD)
 sbi(PORT_WR,WR_RAM); //set not(WR)
 outp(0xFF,PORT_RAM_CONTROL); //port to writemode
 outp(Address,PORT_RAM_OUT); //write Address
 sbi(PORT_ALE,ALE_RAM); //set ALE
 NOP(); //Wait
 NOP(); //Wait
 NOP(); //Wait
 cbi(PORT_ALE,ALE_RAM); //clear ALE
 outp(Value,PORT_RAM_OUT); //write Value
 NOP(); // ? wait
 NOP(); //Wait
 NOP(); //Wait
 cbi(PORT_WR,WR_RAM); //clear not(WR)
 NOP(); //Wait
 NOP(); //Wait
 NOP(); //Wait
 sbi(PORT_WR,WR_RAM); //set not(WR)
}

u08 RD(u08 Address) // Read from the RAM
{
 u08 value = 0x00;
 sbi(PORT_WR,WR_RAM); //set not(WR)
 sbi(PORT_RD,RD_RAM); //set not(RD)
 outp(0xFF,PORT_RAM_CONTROL); //port to writemode
 outp(Address,PORT_RAM_OUT); //write Address
 sbi(PORT_ALE,ALE_RAM); //set ALE
 NOP(); //wait
 NOP(); //Wait
 NOP(); //Wait
 cbi(PORT_ALE,ALE_RAM); //clear ALE
 cbi(PORT_RD,RD_RAM); //clear not(RD)
 outp(0x00,PORT_RAM_CONTROL); //port to readmode
 outp(0x00,PORT_RAM_OUT);
 NOP(); //wait
 NOP(); //Wait
 NOP(); //Wait
 value = PORT_RAM_IN; // read and save the value *** modified
 NOP(); //wait
 NOP(); //Wait
 NOP(); //Wait
 sbi(PORT_RD,RD_RAM); //set not(RD)
 return value;
}